open Format ;;
open Graphics ;;

let width = 640
and height = 640 ;;

let main () =
  if Array.length Sys.argv < 2 then
    begin
      eprintf "%s: argument expected@." Sys.argv.(0) ;
      eprintf "Try `%s --help' for more information.@." Sys.argv.(0) ;
      exit 1
    end ;
  if Sys.argv.(1) = "--help" then
    begin
      printf "usage: %s DIR   # browse directory DIR@." Sys.argv.(0) ;
      printf "or     %s -     # browse dictionnary@." Sys.argv.(0) ;
      printf "@." ;
      printf "key bindings:@." ;
      printf "  c  center the root@." ;
      printf "  s  save figure in `htree.eps'@." ;
      printf "  q  quit@." ;
      exit 0
    end ;
  if Array.length Sys.argv > 2 then
    eprintf "%s: ignoring trailing arguments@." Sys.argv.(0) ;
  if Sys.argv.(1) = "-" then
    let module GT = Gtree.Make(DictTree) in
    GT.show_tree DictTree.root width height
  else
    let module GT = Gtree.Make(DirTree) in
    GT.show_tree (DirTree.from_dir "" Sys.argv.(1)) width height ;;

main () ;;
